{
    "scan": {
        "analyzer-version-clang": "18.1.7",
        "analyzer-version-cppcheck": "2.14.2",
        "analyzer-version-gcc": "14.1.1",
        "analyzer-version-gcc-analyzer": "14.1.1",
        "analyzer-version-shellcheck": "0.10.0",
        "enabled-plugins": "clang, cppcheck, gcc, shellcheck",
        "exit-code": 0,
        "host": "ip-172-16-1-131.us-west-2.compute.internal",
        "mock-config": "fedora-41-x86_64",
        "project-name": "perl-Encode-3.21-510.fc41",
        "store-results-to": "/tmp/tmpqjt_ozwf/perl-Encode-3.21-510.fc41.tar.xz",
        "time-created": "2024-07-03 16:39:46",
        "time-finished": "2024-07-03 16:41:08",
        "tool": "csmock",
        "tool-args": "'/usr/bin/csmock' '-r' 'fedora-41-x86_64' '-t' 'cppcheck,gcc,clang,shellcheck' '-o' '/tmp/tmpqjt_ozwf/perl-Encode-3.21-510.fc41.tar.xz' '--gcc-analyze' '/tmp/tmpqjt_ozwf/perl-Encode-3.21-510.fc41.src.rpm'",
        "tool-version": "csmock-3.5.3-1.el9"
    },
    "defects": [
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/encengine.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Byte/Byte.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/CN/CN.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/EBCDIC/EBCDIC.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "hash_v1": "39e8e3d7e1c785449d5693cd56a244b9d7e33437",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 430,
                    "column": 9,
                    "event": "warning[core.NonNullParamChecker]",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2879,
                    "column": 91,
                    "event": "note",
                    "message": "expanded from macro 'Move'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 395,
                    "column": 23,
                    "event": "note",
                    "message": "Assuming 'strict' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 395,
                    "column": 23,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 399,
                    "column": 9,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 399,
                    "column": 5,
                    "event": "note",
                    "message": "Taking true branch",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 414,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is false.  Exiting loop",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/sv.h",
                    "line": 1529,
                    "column": 9,
                    "event": "note",
                    "message": "expanded from macro 'SvCUR_set'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/perl.h",
                    "line": 864,
                    "column": 23,
                    "event": "note",
                    "message": "expanded from macro 'STMT_START'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 416,
                    "column": 13,
                    "event": "note",
                    "message": "Assuming 's' is null",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 416,
                    "column": 15,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 417,
                    "column": 16,
                    "event": "note",
                    "message": "Assuming the condition is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/sv.h",
                    "line": 2504,
                    "column": 10,
                    "event": "note",
                    "message": "expanded from macro 'SvGROW'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/sv.h",
                    "line": 2080,
                    "column": 35,
                    "event": "note",
                    "message": "expanded from macro 'SvIsCOW'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/sv.h",
                    "line": 374,
                    "column": 21,
                    "event": "note",
                    "message": "expanded from macro 'SvFLAGS'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 417,
                    "column": 16,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/sv.h",
                    "line": 2504,
                    "column": 22,
                    "event": "note",
                    "message": "expanded from macro 'SvGROW'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 419,
                    "column": 23,
                    "event": "note",
                    "message": "Assuming 'stop_at_partial' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 419,
                    "column": 39,
                    "event": "note",
                    "message": "Left side of '||' is true",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 421,
                    "column": 12,
                    "event": "note",
                    "message": "Assuming 's' is < 'e'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 421,
                    "column": 5,
                    "event": "note",
                    "message": "Loop condition is true.  Entering loop body",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 430,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '||' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2879,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'Move'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2773,
                    "column": 32,
                    "event": "note",
                    "message": "expanded from macro 'MEM_WRAP_CHECK_'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2761,
                    "column": 25,
                    "event": "note",
                    "message": "expanded from macro 'MEM_WRAP_CHECK'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2757,
                    "column": 9,
                    "event": "note",
                    "message": "expanded from macro '_MEM_WRAP_WILL_WRAP'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2736,
                    "column": 8,
                    "event": "note",
                    "message": "expanded from macro '_MEM_WRAP_NEEDS_RUNTIME_CHECK'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 430,
                    "column": 9,
                    "event": "note",
                    "message": "'?' condition is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2879,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'Move'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2773,
                    "column": 32,
                    "event": "note",
                    "message": "expanded from macro 'MEM_WRAP_CHECK_'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2761,
                    "column": 25,
                    "event": "note",
                    "message": "expanded from macro 'MEM_WRAP_CHECK'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2757,
                    "column": 9,
                    "event": "note",
                    "message": "expanded from macro '_MEM_WRAP_WILL_WRAP'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2736,
                    "column": 5,
                    "event": "note",
                    "message": "expanded from macro '_MEM_WRAP_NEEDS_RUNTIME_CHECK'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 430,
                    "column": 9,
                    "event": "note",
                    "message": "Left side of '&&' is false",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2879,
                    "column": 24,
                    "event": "note",
                    "message": "expanded from macro 'Move'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2773,
                    "column": 32,
                    "event": "note",
                    "message": "expanded from macro 'MEM_WRAP_CHECK_'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2762,
                    "column": 9,
                    "event": "note",
                    "message": "expanded from macro 'MEM_WRAP_CHECK'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.xs",
                    "line": 430,
                    "column": 9,
                    "event": "note",
                    "message": "Null pointer passed to 2nd parameter expecting 'nonnull'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "/usr/lib64/perl5/CORE/handy.h",
                    "line": 2879,
                    "column": 91,
                    "event": "note",
                    "message": "expanded from macro 'Move'",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  428|   ",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  429|           /* Copy as far as was successful */",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  430|->         Move(s, d, len, U8);",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  431|           d += len;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  432|           s = (U8 *) e_or_where_failed;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "hash_v1": "b47c567ac6254363be2e26467a73584e4900c3a6",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.c",
                    "line": 971,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'obj' during its initialization is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.c",
                    "line": 971,
                    "column": 7,
                    "event": "note",
                    "message": "Value stored to 'obj' during its initialization is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  969|          croak_xs_usage(cv,  \"obj\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  970|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  971|-> \tSV *\tobj = ST(0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  972|   ;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  973|   \tint\tRETVAL;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "hash_v1": "b47c567ac6254363be2e26467a73584e4900c3a6",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.c",
                    "line": 1188,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'obj' during its initialization is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.c",
                    "line": 1188,
                    "column": 7,
                    "event": "note",
                    "message": "Value stored to 'obj' during its initialization is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1186|          croak_xs_usage(cv,  \"obj\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1187|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1188|-> \tSV *\tobj = ST(0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1189|   ;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1190|   \tbool\tRETVAL;",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "hash_v1": "b47c567ac6254363be2e26467a73584e4900c3a6",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.c",
                    "line": 1208,
                    "column": 7,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'obj' during its initialization is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Encode.c",
                    "line": 1208,
                    "column": 7,
                    "event": "note",
                    "message": "Value stored to 'obj' during its initialization is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1206|          croak_xs_usage(cv,  \"obj\");",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1207|       {",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1208|-> \tSV *\tobj = ST(0)",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1209|   ;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": " 1210|   #line 894 \"Encode.xs\"",
                    "verbosity_level": 1
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/JP/JP.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/KR/KR.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Symbol/Symbol.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/TW/TW.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CPPCHECK_WARNING",
            "language": "c/c++",
            "tool": "cppcheck",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Unicode/Unicode.c",
                    "line": 0,
                    "event": "information[normalCheckLevelMaxBranches]",
                    "message": "Limiting analysis of branches. Use --check-level=exhaustive to analyze all branches.",
                    "verbosity_level": 0
                }
            ]
        },
        {
            "checker": "CLANG_WARNING",
            "language": "c/c++",
            "tool": "clang",
            "hash_v1": "6ed3531650dc878c2cdcb97943114be006dbef2b",
            "key_event_idx": 0,
            "events": [
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Unicode/Unicode.c",
                    "line": 719,
                    "column": 17,
                    "event": "warning[deadcode.DeadStores]",
                    "message": "Value stored to 'file' during its initialization is never read",
                    "verbosity_level": 0
                },
                {
                    "file_name": "/builddir/build/BUILD/perl-Encode-3.21-build/Encode-3.21/Unicode/Unicode.c",
                    "line": 719,
                    "column": 17,
                    "event": "note",
                    "message": "Value stored to 'file' during its initialization is never read",
                    "verbosity_level": 2
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  717|       char* file = __FILE__;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  718|   #else",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  719|->     const char* file = __FILE__;",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  720|   #endif",
                    "verbosity_level": 1
                },
                {
                    "file_name": "",
                    "line": 0,
                    "event": "#",
                    "message": "  721|   ",
                    "verbosity_level": 1
                }
            ]
        }
    ]
}
